#
# Test the config view
#

from Products.Maps.tests import MapsTestCase

from Products.Maps.config import PROPERTY_GOOGLE_KEYS_FIELD
from Products.CMFCore.utils import getToolByName


class TestConfig(MapsTestCase.MapsTestCase):

    def testViewAvailable(self):
        config = self.folder.restrictedTraverse('@@maps_configuration')

    def testGoogleAPIKey(self):
        config = self.folder.restrictedTraverse('@@maps_configuration')
        propertiestool = getToolByName(self.portal, 'portal_properties')
        mapsprops = getattr(propertiestool.aq_base, 'maps_properties')
        # test whether the key is found on exact url match
        mapsprops._updateProperty(PROPERTY_GOOGLE_KEYS_FIELD,
                                  ["http://nohost/plone | MyKey"])
        self.assertEqual(config.googlemaps_key, "MyKey")
        # test whether the key is found on partial url match
        mapsprops._updateProperty(PROPERTY_GOOGLE_KEYS_FIELD,
                                  ["http://nohost | MyOtherKey"])
        self.assertEqual(config.googlemaps_key, "MyOtherKey")
        # test longest first matching key - one
        mapsprops._updateProperty(PROPERTY_GOOGLE_KEYS_FIELD,
                                  ["http://nohost | MyOtherKey",
                                   "http://nohost/plone | MyKey"])
        self.assertEqual(config.googlemaps_key, "MyKey")
        # test longest first matching key - two
        mapsprops._updateProperty(PROPERTY_GOOGLE_KEYS_FIELD,
                                  ["http://nohost/plone | MyKey",
                                   "http://nohost | MyOtherKey"])
        self.assertEqual(config.googlemaps_key, "MyKey")
        # test longest first matching key - three
        mapsprops._updateProperty(PROPERTY_GOOGLE_KEYS_FIELD,
                                  ["http://dummy/plone | MyKey",
                                   "http://nohost | MyOtherKey"])
        self.assertEqual(config.googlemaps_key, "MyOtherKey")
        # test whitespace stripping
        mapsprops._updateProperty(PROPERTY_GOOGLE_KEYS_FIELD,
                                  ["   http://nohost/plone | MyKey   "])
        self.assertEqual(config.googlemaps_key, "MyKey")
        # test no whitespace
        mapsprops._updateProperty(PROPERTY_GOOGLE_KEYS_FIELD,
                                  ["http://nohost/plone|MyKey"])
        self.assertEqual(config.googlemaps_key, "MyKey")


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestConfig))
    return suite
